Package: rasciidoc
Title: Create Reports Using R and 'asciidoc'
Version: 4.1.1
Authors@R: 
    person(given = "Andreas Dominik",
           family = "Cullmann",
           role = c("aut", "cre"),
           email = "fvafrcu@mailbox.org")
Description: Inspired by Karl Broman`s reader on using 'knitr'
    with 'asciidoc'
    (<https://kbroman.org/knitr_knutshell/pages/asciidoc.html>), this is
    merely a wrapper to 'knitr' and 'asciidoc'.
License: BSD_2_clause + file LICENSE
URL: https://gitlab.com/fvafrcu/rasciidoc
Depends: R (>= 3.3.0)
Imports: checkmate, fritools (>= 3.7.1), gert, highr, knitr,
        reticulate, tools
Suggests: devtools, pkgload, rmarkdown, rprojroot, RUnit, testthat,
        withr
Encoding: UTF-8
RoxygenNote: 7.2.3
SystemRequirements: python >= 2.6, by default rasciidoc uses a system
        installation of asciidoc. If a system installation of asciidoc
        is not available, it downloads the sources from
        (<http://gitlab.com/asciidoc>). GNU source-highlight is
        recommended.
VignetteBuilder: rasciidoc
NeedsCompilation: no
Packaged: 2023-08-15 21:58:49 UTC; qwer
Author: Andreas Dominik Cullmann [aut, cre]
Maintainer: Andreas Dominik Cullmann <fvafrcu@mailbox.org>
Repository: CRAN
Date/Publication: 2023-08-15 22:20:02 UTC
Built: R 4.6.0; ; 2026-04-26 14:43:05 UTC; unix

[![pipeline status](https://gitlab.com/fvafrcu/rasciidoc/badges/master/pipeline.svg)](https://gitlab.com/fvafrcu/rasciidoc/-/commits/master)    
[![coverage report](https://gitlab.com/fvafrcu/rasciidoc/badges/master/coverage.svg)](https://gitlab.com/fvafrcu/rasciidoc/-/commits/master)
<!-- 
    [![Build Status](https://travis-ci.org/fvafrcu/rasciidoc.svg?branch=master)](https://travis-ci.org/fvafrcu/rasciidoc)
    [![Coverage Status](https://codecov.io/github/fvafrcu/rasciidoc/coverage.svg?branch=master)](https://codecov.io/github/fvafrcu/rasciidoc?branch=master)
-->
[![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/rasciidoc)](https://cran.r-project.org/package=rasciidoc)
[![RStudio_downloads_monthly](https://cranlogs.r-pkg.org/badges/rasciidoc)](https://cran.r-project.org/package=rasciidoc)
[![RStudio_downloads_total](https://cranlogs.r-pkg.org/badges/grand-total/rasciidoc)](https://cran.r-project.org/package=rasciidoc)

<!-- README.md is generated from README.Rmd. Please edit that file -->



# rasciidoc
## Introduction
Please read the help page:

```r
help("rasciidoc-package", package = "rasciidoc")
```

```
#> Create Reports Using R and 'asciidoc'
#> 
#> Description:
#> 
#>      Inspired by Karl Broman`s reader on using 'knitr' with 'asciidoc'
#>      (<https://kbroman.org/knitr_knutshell/pages/asciidoc.html>), this
#>      is merely a wrapper to 'knitr' and 'asciidoc'.
#> 
#> Arguments:
#> 
#> write_to_disk: Write to disk? See *Warning*.
#> 
#> Details:
#> 
#>      You will find the details in
#>      'vignette("An_Introduction_to_rasciidoc", package = "rasciidoc")'.
#> 
#> Warning:
#> 
#>      Due to the CRAN policy of not writing "anywhere else on the file
#>      system apart from the R session's temporary directory", we work on
#>      a temporary copy of 'file_name'. Thus all internal sourcing and
#>      internal links will be broken and any output is written to
#>      'tempdir()'. Set the option "write_to_disk" to TRUE (using
#>      'options(write_to_disk = TRUE)'
#>      to bypass this. You may want to include the above line into your
#>      '~/.Rprofile'.
```

## Installation

You can install rasciidoc from gitlab via:


```r
if (! require("remotes")) install.packages("remotes")
remotes::install_gitlab("fvafrcu/rasciidoc")
```

file_name <- system.file("files", "minimal", "plot.Rasciidoc",
                         package = "rasciidoc")
cat(readLines(file_name), sep = "\n")

withr::with_dir(tempdir(), {
                    file.copy(file_name, ".")
                    rasciidoc::render(basename(file_name))
})

file_name <- system.file("files", "simple", "knit.Rasciidoc",
                         package = "rasciidoc")
cat(readLines(file_name), sep = "\n")

my_directory <- file.path(tempdir(), "simple")
dir.create(my_directory)
withr::with_dir(my_directory, {
                    file.copy(file_name, ".")
                    file.copy(file.path(dirname(file_name), "src"), ".",
                              recursive = TRUE)
})
dir(my_directory, recursive = TRUE, full.names = TRUE)

rasciidoc::render(file.path(my_directory, basename(file_name)))

file_name <- system.file("files", "simple", "spin.R_nolint",
                         package = "rasciidoc")
cat(readLines(file_name), sep = "\n")

withr::with_dir(tempdir(), {
                    file.copy(file_name, ".", overwrite = TRUE)
                    file.copy(file.path(dirname(file_name), "src"), ".",
                              recursive = TRUE)
                    rasciidoc::render(basename(file_name))
})

if (interactive()) pkgload::load_all()
ex <- c(paste("<span class=\"hl kwd\">print</span><span",
              "class=\"hl std\">(</span><span class=\"hl",
              "num\">3</span><span class=\"hl std\">)</span>"),
        paste("<span class=\"hl kwa\">if</span> <span class=\"hl",
              "std\">(</span><span class=\"hl",
              "num\">FALSE</span><span",
              "class=\"hl std\">)</span> <span class=\"hl",
              "kwd\">print</span><span class=\"hl",
              "std\">(</span><span",
              "class=\"hl num\">3</span><span class=\"hl",
              "std\">)</span>",
              "<span class=\"hl kwa\">else</span> <span",
              "class=\"hl kwd\">print</span><span class=\"hl",
              "std\">(</span><span class=\"hl num\">4</span><span",
              "class=\"hl std\">)</span>")
        )
test_highlight_source <- function(expectation = ex) {
    # TODO: This one fails on CRAN:
    ## ERROR in test_highlight_source: Error in if (res[n] == "\\normalsize")
    ##   res = res[-n] :
    ##   argument is of length zero
    # I don't have a clue why res = try(...) returns no error but length(res)
    # is zero...
    if (fritools::is_running_on_fvafrcu_machines()) {
        x <- c("print(3)", "if (FALSE) print(3) else print(4)")
        result <- rasciidoc:::hilight_source(x, "html",
                                             list(highlight = TRUE,
                                                  engine = "R",
                                                  prompt = FALSE))
        RUnit::checkIdentical(result, expectation)
        result <- rasciidoc:::hilight_source(x, "html",
                                             list(highlight = TRUE,
                                                  engine = "",
                                                  prompt = FALSE))
        expectation <- result
        RUnit::checkIdentical(result, expectation)
        result <- rasciidoc:::hilight_source(x, "html",
                                             list(highlight = FALSE,
                                                  engine = "",
                                                  prompt = TRUE))
        expectation <- c("> print(3)", "> if (FALSE) print(3) else print(4)")
        RUnit::checkIdentical(result, expectation)
    }
}

test_knitr_internals <- function() {
    RUnit::checkIdentical(rasciidoc:::comment_length(NULL), 1L)
    RUnit::checkIdentical(rasciidoc:::comment_length(1), 2L)
}

test_merge_lists <- function() {
    x <- list(foo = 1, bar = 1, foobar = 3)
    y <- list(foo = 2, bar = 7)
    result <- rasciidoc:::merge_list(x, y)
    expectation <- structure(list(foo = 2, bar = 7, foobar = 3),
                             .Names = c("foo", "bar", "foobar"))
    RUnit::checkIdentical(result, expectation)
}

if (interactive()) pkgload::load_all()
test_try_parse <- function() {
    RUnit::checkTrue(rasciidoc:::try_parse("asdf"))
    RUnit::checkTrue(! rasciidoc:::try_parse("a(df"))
}

test_escape_latex <- function() {
    RUnit::checkIdentical(rasciidoc:::escape_latex("\\{"),
                          "\\textbackslash{}\\{")
}

test_escape_html <- function() {
    RUnit::checkIdentical(rasciidoc:::escape_html("& < > \""),
                          "&amp; &lt; &gt; &quot;")
}

test_group_src <- function()  {
    # adapted from highr/tests/testit/test-utils.R
    RUnit::checkIdentical(rasciidoc:::group_src("1+1"), list("1+1"))
    RUnit::checkIdentical(rasciidoc:::group_src(c("1+1+", "1")),
                          list(c("1+1+", "1")))
    RUnit::checkIdentical(rasciidoc:::group_src(c("1+1+", "1", "TRUE")),
                          list(c("1+1+", "1"), "TRUE"))
}

if (interactive()) pkgload::load_all()
test_excerption <- function() {

    file.copy(system.file("runit_tests", "files", "excerption_file.Rasciidoc",
              package = "rasciidoc"), tempdir(), overwrite = TRUE)

   # slides
    path <- rasciidoc:::excerpt_slides(file.path(tempdir(),
                                                 "excerption_file.Rasciidoc"))
    result <- readLines(path)
    expectation <- readLines(system.file("runit_tests", "files",
                                         "expected", "excerpted_slides.txt",
                                         package = "rasciidoc"))
    RUnit::checkIdentical(result, expectation)

    # no slides
    path <- rasciidoc:::excerpt_no_slides(file.path(tempdir(),
                                                    "excerption_file.Rasciidoc")
    )
    result <- readLines(path)
    expectation <- readLines(system.file("runit_tests", "files",
                                         "expected", "excerpted_no_slides.txt",
                                         package = "rasciidoc"))
    RUnit::checkIdentical(result, expectation)

}

if (interactive()) pkgload::load_all()
remove_dates <- function(x) {
  grep("^ *20[0-9]{2}.[0-9]{2}.[0-9]{2}", value = TRUE, invert = TRUE,
    grep(".*CE[S]?T$", value = TRUE, invert = TRUE,
         grep(".*UTC$", value = TRUE, invert = TRUE, x)
         )
  )
}

remove_if_true <- function(x) {
    ## covr::package_coverage inserts `if (TRUE) {` ...
    return(gsub("if\\(TRUE\\)\\{", "", x))
}

skip <- function() {
    skip <- !(fritools::is_running_on_fvafrcu_machines() ||
              fritools::is_running_on_gitlab_com())
    return(skip)
}
if (!skip()) {
        test_rasciidoc_simple <- function() {
            folder  <- system.file("runit_tests", "files",
                                   package = "rasciidoc")
            adoc <- file.path(folder, "simple.asciidoc")
            wdir <- tempfile()
            dir.create(wdir)
            on.exit(unlink(wdir, recursive = TRUE))
            file.copy(adoc, wdir)
            # misspecified arguments
            withr::with_dir(tempdir(),
                            status <-
                                rasciidoc(file.path(wdir,
                                                    basename(adoc)),
                                          write_to_disk = FALSE,
                                          enforce_requirements = FALSE,
                                          "-b does_not_exists")
                            )
            RUnit::checkTrue(isTRUE(!status))

            withr::with_dir(tempdir(),
                            status <-
                                rasciidoc(file.path(wdir,
                                                    basename(adoc)))
                            )
            if (fritools::is_installed(rasciidoc:::discover_python())) {
                RUnit::checkTrue(isTRUE(status))
                result <- readLines(file.path(tempdir(), "simple.html"))
                pattern <- "(^([-:[]|$)|\\t)"
                if (!fritools::is_installed("source-highlight")) {
                    pattern <- paste0(pattern, "|\\(.*\\)")
                }
                expected <- grep(value = TRUE, invert = TRUE,
                                 pattern = pattern,
                                 readLines(adoc))
                expected <- trimws(sub("^=* ", "", expected))
                hit <- sapply(expected,
                              function(x) any(grepl(x, result, fixed = TRUE)))
                RUnit::checkTrue(all(hit))
            } else {
                RUnit::checkTrue(isTRUE(!status))
            }
        }

        if (interactive()) test_rasciidoc_simple()
    test_render_simple <- function() {
        folder <- system.file("runit_tests", "files", package = "rasciidoc")
        file.copy(folder, tempdir(), recursive = TRUE)
        on.exit(unlink(file.path(tempdir(), "files"), recursive = TRUE))
        #% render
        withr::with_dir(file.path(tempdir(), "files"),
                        status <- render("simple.Rasciidoc"))
        infile <- file.path(tempdir(), "files", "simple.Rasciidoc")
        if (fritools::is_installed(rasciidoc:::discover_python())) {
            RUnit::checkTrue(isTRUE(status))
            result <- readLines(file.path(tempdir(), "simple.html"))
            pattern <- "(^([:/]|$)|\\t)"
            if (!fritools::is_installed("source-highlight")) {
                pattern <- paste0(pattern, "|\\(.*\\)")
            }
            data(mtcars)
            expected <- c(readLines(infile), capture.output(str(mtcars)))
            expected <- grep(value = TRUE, invert = TRUE,
                             pattern = pattern,
                             expected)
            expected <- trimws(sub("^=* ", "", expected))
            hit <- sapply(expected,
                          function(x) any(grepl(x, result, fixed = TRUE)))
            RUnit::checkTrue(all(hit))
        } else {
            RUnit::checkTrue(isTRUE(!status))
        }

    }
    if (interactive()) test_render_simple()
    test_render_slides <- function() {
        ##% render slides
        message("FIXME: need coverage for slides?")
        folder <- system.file("runit_tests", "files", package = "rasciidoc")
        file.copy(folder, tempdir(), recursive = TRUE)
        on.exit(unlink(file.path(tempdir(), "files"), recursive = TRUE))

        # file contains no R code
        withr::with_dir(file.path(tempdir(), "files"),
                        status <- render("fake.Radoc", knit = NA))
        if (!fritools::is_installed(rasciidoc:::discover_python())) {
            RUnit::checkTrue(isTRUE(!status))
        } else {
            RUnit::checkTrue(isTRUE(status))
            result <- remove_dates(readLines(file.path(tempdir(),
                                                       "fake.html")))
            if (FALSE) {
                file.copy(file.path(tempdir(), "fake.html"),
                          file.path("inst", "runit_tests", "files", "expected"),
                          overwrite = TRUE
                          )
            }
            expectation <- remove_dates(readLines(file.path(tempdir(), "files",
                                                            "expected",
                                                            "fake.html")))
            # don't know which version of asciidoc will be used on remote
            # machines
            if (fritools::is_running_on_fvafrcu_machines())
                RUnit::checkIdentical(result, expectation)
        }
    }
    if (interactive()) test_render_slides()

    test_knit_spin <- function() {
        old_wd <- setwd(tempdir())
        on.exit(setwd(old_wd))
        dir <- system.file("files", "simple", package = "rasciidoc")
        file.copy(list.files(dir, full.names = TRUE), ".", recursive = TRUE)
        # lintr inevitably reads spin.R and crashes
        # (I tried all kindes of exlusions...).
        # I therefore moved spin.R to
        # spin.R_nolint to make lintr not read the file.
        # But I need it to end on R or r when deciding
        # whether to knit or spin. So I rename here:
        file.rename("spin.R_nolint", "spin.R")
        render("spin.R")
        file.copy("spin.asciidoc", "foo.asciidoc")
        status <- rasciidoc("foo.asciidoc")
        if (!fritools::is_installed(rasciidoc:::discover_python())) {
            RUnit::checkTrue(isTRUE(!status))
        } else {
            RUnit::checkTrue(isTRUE(status))
            spin <- remove_dates(readLines("spin.html"))
            ascii_md <- remove_dates(readLines("foo.html"))
            # don't know which version of asciidoc will be
            # used on remote machines
            if (fritools::is_running_on_fvafrcu_machines())
                RUnit::checkIdentical(spin, ascii_md)
        }
        render(file_name = "knit.Rasciidoc")
        render("knit.Rasciidoc", clean = FALSE,
               what = "all")
        file.copy("knit.asciidoc", "bar.asciidoc")
        status <- rasciidoc("bar.asciidoc")
        if (!fritools::is_installed(rasciidoc:::discover_python())) {
            RUnit::checkTrue(isTRUE(!status))
        } else {
            RUnit::checkTrue(isTRUE(status))
            knit <- remove_dates(readLines("knit.html"))
            ascii <- remove_dates(readLines("bar.html"))
            # don't know which version of asciidoc will be
            # used on remote machines
            if (fritools::is_running_on_fvafrcu_machines())
                RUnit::checkIdentical(knit, ascii)
        }
    }

    test_adjusting_hooks <- function() {
        if (grepl(paste0("^", dirname(tempdir()), ".*$"), getwd()) && FALSE) {
            warning("skipping test for covr")
        } else {
            # if this fails, insert prints or messages,
            # run covr::package_coverage(path = ".", clean = FALSE), read
            # the output, it will point you to something like
            # /tmp/RtmpXXX/R_LIBSXXX/rasciidoc/rasciidoc-tests/runit.Rout.fail
            on.exit(knitr::knit_hooks$restore())
            # covr infects functions, so we deparse an grep them first

            clean <- function(x) {
                r <- gsub(" ", "", paste0(grep("covr:::count|   \\{$|   \\}$",
                                               invert = TRUE, value = TRUE,
                                               deparse(x)),
                                       collapse = ""))
                return(remove_if_true(r))
            }
            # get a verbartim copy from adjust_knitr_hooks:
            hook_source <- function(x, options) {
                x <- paste(c(hilight_source(x, "asciidoc", options), ""),
                           collapse = "\n")
                sprintf("\n[source,%s]\n----\n%s----\n",
                        tolower(options$engine),
                        x)
            }
            hook_message <- function(x, options) {
                sprintf("\n[NOTE]\n====\n.Message\n%s\n====\n",
                        substring(x, comment_length(options$comment)))
            }
            hook_warning <- function(x, options) {
                sprintf("\n[WARNING]\n====\n.Warning\n%s\n====\n",
                        gsub("^.*Warning: ", "", x))
            }
            hook_error <- function(x, options) {
                sprintf("\n[CAUTION]\n====\n.Error\n%s\n====\n",
                        gsub("^.*Error: ", "", x))
            }
            hook_output <- function(x, options) sprintf("\n----\n%s----\n", x)
            knitr::knit_hooks$restore()
            adjust_asciidoc_hooks(replacement = NULL)
            cs <- knitr::knit_hooks$get("source")
            co <- knitr::knit_hooks$get("output")
            cm <- knitr::knit_hooks$get("message")
            cw <- knitr::knit_hooks$get("warning")
            ce <- knitr::knit_hooks$get("error")
            RUnit::checkEquals(clean(cs), clean(hook_source))
            RUnit::checkEquals(clean(co), clean(hook_output))
            RUnit::checkEquals(clean(cm), clean(hook_message))
            RUnit::checkEquals(clean(cw), clean(hook_warning))
            RUnit::checkEquals(clean(ce), clean(hook_error))
            adjust_asciidoc_hooks(hooks = c("message", "warning",
                                            "error"),
                                  replacement = "source")
            cs <- knitr::knit_hooks$get("source")
            co <- knitr::knit_hooks$get("output")
            cm <- knitr::knit_hooks$get("message")
            cw <- knitr::knit_hooks$get("warning")
            ce <- knitr::knit_hooks$get("error")
            RUnit::checkEquals(clean(cs), clean(hook_source))
            RUnit::checkEquals(clean(co), clean(hook_output))
            RUnit::checkEquals(clean(cm), clean(hook_source))
            RUnit::checkEquals(clean(cw), clean(hook_source))
            RUnit::checkEquals(clean(ce), clean(hook_source))
            adjust_asciidoc_hooks(hooks = c("source"),
                                  replacement = "error")
            cs <- knitr::knit_hooks$get("source")
            RUnit::checkEquals(clean(cs), clean(hook_error))
        }
    }
}

---
title: Some Title
author: Your Name
---

= What is this About?

This will not show up on slides.

== Some simple asciidoc

* A list with a [link](https://en.wikipedia.org/wiki/Hyperlink).
* Yet another entry in the list.

= Including Code
Do not use the _include_ macro provided by asciidoc! 
``` {r, code = readLines("src/sum.R")}
``` 

= A new section
``` {r, code = readLines("src/my_sum.R")}
``` 

= Only sections give new slides 
== A subsection
``` {r}
print(value)
``` 

``` {r}
print(my_sum(1:3))
``` 

Some inline code: Object `value` has value `r value`.

= Next slide 

== Second subsection

= Some Title
Your Name
:toc2:
:numbered:
:data-uri:
:duration: 120

== What is this About?

=== Some simple asciidoc

* A list with a https://en.wikipedia.org/wiki/Hyperlink[link].
* Yet another entry in the list.

== Including Code
Do not use the _include_ macro provided by asciidoc!
Instead prefix all source statements with 
----
#+ code = readLines("file_to_be_sourced")
#+ include = FALSE
----
It est use
----
#+ code = readLines("src/sum.R")
#+ include = FALSE
source("src/sum.R")
----
to produce


[source,r]
----
a  <- c(2, 3, 4, 10) # <1>
value <- 0 # <2>
for (a_i in a) { # <3>
    value <- value + a_i  # <4>
}
print(value) # <5>
----

----
## [1] 19
----





== A new section



[source,r]
----
my_sum <- function(x) {
    value <- 0
    for (x_i in x) {
        value <- value + x_i 
    }
    return(value)
}
----


=== A subsection


[source,r]
----
print(value)
----

----
## [1] 19
----





[source,r]
----
print(my_sum(1:3))
----

----
## [1] 6
----



Inline code does not work: Object +value+ has value +r value+.
